"use strict";(self.webpackChunkPlesk=self.webpackChunkPlesk||[]).push([["views/admin/ip-address/list"],{1852:(e,t,s)=>{s.r(t),s.d(t,{default:()=>P});var n=s(240),i=s(242),r=s.n(i),a=s(241),d=s(825),l=s(90),o=s(1853),c=s(682),p=s(680),u=s(446),m=s(711),x=s(1662);const g=l.Locale.getTranslate("admin.components.forms.ip-address"),j=l.Locale.getSection("admin.components.forms.ip-address"),h=l.Locale.getTranslate("admin.components.forms.security-policy"),f=u.gql`
    fragment generalFields on Query {
        certificates(fromServerRepository: true) {
            id
            name
            repositoryName
        }
        server {
            settings {
                ftpOverSSL
            }
            ipAddresses {
                interfaces
            }
        }
        os {
            isIPv6Supported
            isWindows
        }
        capability {
            panel {
                accessDriver {
                    isHttpsProxyEnabled
                    isDefaultAccessDomain
                }
            }
            ftp {
                isExplicitSSL
            }
        }
    }
`,b=u.gql`
    ${f}
    query UpdateIpAddressValues($id: ID!) {
        ...generalFields
        ipAddress: node(id: $id) {
            ... on IpAddress {
                id
                type
                onRepairMode
                ipAddress
                publicIpAddress
                ftpOverSSL
                isIPv6
                interface
                certificate {
                    id
                    name
                    repositoryName
                }
                defaultDomain {
                    id
                }
                domains {
                    id
                    name(idn: false)
                    owner {
                        name
                    }
                }
            }
        }
    }
`,S=u.gql`
    ${f}
    query CreateIpAddressValues{
        ...generalFields
    }
`,v=u.gql`
    mutation UpdateIpAddress($input: UpdateIpAddressInput!){
        updateIpAddress(input: $input) {
            ipAddress
            task {
                id
            }
        }
    }
`,A=({children:e})=>(0,n.jsxs)(n.Fragment,{children:[(0,n.jsx)("hr",{}),(0,n.jsx)(a.Text,{bold:!0,style:{fontSize:"1.2rem"},children:(0,n.jsx)(h,{content:"secureFtpSection"})}),e]}),y="/cp/ip-address",I=({onSuccess:e})=>{const t=(0,c.useNavigate)(),s=(0,c.useMatch)(`${y}/add`),i=(0,c.useMatch)(`${y}/:id/edit`),r=!(!s&&!i),[u,f]=(0,n.useState)(null),[I,{loading:P}]=(0,m.useMutation)(v),[C,{data:k,loading:T}]=(0,x.useLazyQuery)(s?S:b,{onCompleted:e=>{const{ipAddress:t={},server:n={}}=e;f((()=>{const i={ftpOverSSL:"CUSTOM"===n.settings.ftpOverSSL?t.ftpOverSSL:n.settings.ftpOverSSL,ipAddress:t.ipAddress,publicIpAddress:t.publicIpAddress??"",type:t.type??"EXCLUSIVE",certificateId:t.certificate?.id??e.certificates[0]?.id,interface:t.interface};return s?i.interface=t.interface??e.server.ipAddresses.interfaces?.[0]:i.defaultDomainId=t.defaultDomain?.id??0,i}))}});(0,n.useEffect)((()=>{if(r){const e=s?{}:{id:i.params.id};C({variables:e})}}),[C,s,i,r]);const D=(0,n.useMemo)((()=>{if(!k||!k?.os.isWindows)return null;const e=k?.capability.ftp.isExplicitSSL;if(!e||!s&&!k.os.isIPv6Supported&&k.ipAddress.isIPv6)return(0,n.jsx)(A,{children:(0,n.jsx)(a.FormField,{label:(0,n.jsx)(h,{content:"ftpOverSsl"}),children:(0,n.jsx)(g,{content:e?"ftpOverSslIpv6NotSupportedByServer":"ftpOverSslNotSupportedByServer"})})});const t="CUSTOM"===k?.server.settings.ftpOverSSL,i=[t?null:{value:"REQUIRED",label:(0,n.jsx)(h,{content:"ftpOverSslOptionRequired"})},{value:"ENABLED",label:(0,n.jsx)(h,{content:"ftpOverSslOptionEnabled"})},{value:"DISABLED",label:(0,n.jsx)(h,{content:"ftpOverSslOptionDisabled"})}].filter((e=>e));return(0,n.jsx)(A,{children:(0,n.jsx)(a.FormFieldRadioButtons,{label:(0,n.jsx)(h,{content:"ftpOverSsl"}),name:"ftpOverSSL",disabled:!t,options:i,description:(0,n.jsx)(h,{content:t?"ftpOverSslCustomHint":"ftpOverSslCustomDisabledHint"})})})}),[k,s]),w=!s&&k?.os.isWindows&&k?.capability.panel.accessDriver.isHttpsProxyEnabled&&k?.capability.panel.accessDriver.isDefaultAccessDomain,E=(0,n.useMemo)((()=>{if(k){const e=k.certificates,t=k.ipAddress?.certificate;return s||!t||e.find((e=>e.id===t.id))||e.push(t),e}return[]}),[k,s]);return(0,n.jsx)(a.Drawer,{"data-type":"ip-address-drawer",isOpen:r,onClose:()=>{t(y)},title:s?(0,n.jsx)(g,{content:"addTitle"}):(0,n.jsx)(g,{content:"editTitle",params:{address:(0,n.jsx)(a.Text,{bold:!0,children:k?.ipAddress.ipAddress||""}),interface:(0,n.jsx)(a.Text,{bold:!0,children:k?.ipAddress.interface||""})}}),form:(0,n.jsx)(d.default,{"data-type":"ip-address-drawer-form",values:u,mutation:I,onSubmit:e=>(s||(e.id=i.params.id),e),onSuccess:({updateIpAddress:{ipAddress:s,task:n}={}})=>{n||(0,p.addToast)({intent:"success",message:l.Locale.getSection("admin.controllers.ip-address.add").lmsg("ipAddressAdded",{address:s})}),t(y),e({task:n})},submitButton:{name:"send","data-action":"submit"},state:P?"loading":void 0,applyButton:!1,children:!k||T?(0,n.jsx)(o.default,{}):(0,n.jsxs)(n.Fragment,{children:[k.ipAddress?.onRepairMode?(0,n.jsx)(a.StatusMessage,{intent:"warning",children:(0,n.jsx)(g,{content:"ipAddressInterfaceNotAvailableWarning",params:{interface:k.ipAddress.interface}})}):null,s||k.ipAddress?.onRepairMode?(0,n.jsx)(a.FormFieldSelect,{name:"interface",label:(0,n.jsx)(g,{content:"interface"}),children:k.server.ipAddresses.interfaces.map((e=>(0,n.jsx)("option",{value:e,children:e},e)))}):null,s?(0,n.jsx)(a.FormFieldText,{name:"ipAddress",size:"lg",description:(0,n.jsx)(g,{content:k.isIPv6Supported?"addressHintIPv6":"addressHintIPv4"}),label:(0,n.jsx)(g,{content:"addressAndSubnetPrefixLength"}),inputProps:{maxLength:255}}):null,(0,n.jsx)(a.FormFieldText,{name:"publicIpAddress",label:(0,n.jsx)(g,{content:"publicIp"}),inputProps:{maxLength:255}}),(0,n.jsx)(a.FormFieldRadioButtons,{name:"type",label:(0,n.jsx)(g,{content:"distributionType"}),options:[{value:"SHARED",label:(0,n.jsx)(g,{content:"distributionTypeShared"})},{value:"EXCLUSIVE",label:(0,n.jsx)(g,{content:"distributionTypeExclusive"})}]}),(0,n.jsx)(a.FormFieldSelect,{name:"certificateId",label:(0,n.jsx)(g,{content:"certificate"}),children:E.map((({id:e,name:t})=>(0,n.jsx)("option",{value:e,children:t},e)))}),s?null:(0,n.jsxs)(a.FormFieldSelect,{name:"defaultDomainId","data-testid":"defaultSite",label:(0,n.jsx)(g,{content:"defaultSite"}),children:[(0,n.jsx)("option",{value:0,children:j.lmsg("none")}),k.ipAddress.domains?.map((({id:e,name:t,owner:{name:s}})=>(0,n.jsx)("option",{value:e,children:`${t} (${s})`},e)))]}),D,w?(0,n.jsx)("div",{style:{marginTop:"2rem"},children:(0,n.jsx)(a.Status,{intent:"warning",children:(0,n.jsx)(g,{content:"accessDomainOnAnyDomainWinWarning",params:{ip:k.ipAddress.ipAddress}})})}):null]})})})};I.propTypes={onSuccess:r().func},I.defaultProps={onSuccess:()=>{}};const P=I},1853:(e,t,s)=>{s.r(t),s.d(t,{default:()=>r});var n=s(241),i=s(240);const r=()=>Array.from({length:6}).map(((e,t)=>(0,i.jsx)(n.FormField,{label:(0,i.jsx)(n.SkeletonText,{lines:1}),children:(0,i.jsx)(n.Skeleton,{maxWidth:300})},t)))},1850:(e,t,s)=>{s.r(t),s.d(t,{default:()=>A});var n=s(240),i=s(241),r=s(724),a=s(90),d=s(680),l=s(1716),o=(s(1851),s(446)),c=s(711),p=s(688),u=s(815),m=s.n(u);const x=o.gql`
    mutation RereadIpAddresses {
        rereadIpAddresses {
            result
        }
    }
`,g=o.gql`
    mutation ReloadPublicIpAddresses {
        reloadPublicIpAddresses {
            task {
                id
            }
        }
    }
`,j=o.gql`
    mutation DeleteIpAddress($ids: [ID!]!) {
        deleteIpAddress(input: { ids: $ids} ) {
            ids
        }
    }
`,h=o.gql`
    mutation RepairIpAddress($id: ID!) {
        repairIpAddress(input: { id: $id }) {
            ipAddress {
                ipAddress
            }
        }
    }
`,f=a.Locale.getTranslate("admin.components.lists.ipaddresses"),b=a.Locale.getSection("admin.components.lists.ipaddresses"),S=a.Locale.getTranslate("components.buttons"),v={page:1,itemsPerPage:25},A=()=>{const[e,t]=(0,n.useState)({search:null,type:null}),[s,o]=(0,n.useState)({sortColumn:null,sortDirection:null}),[u,A]=(0,n.useState)(v),y={...u,...e,...s},[I,{loading:P}]=(0,c.useMutation)(x,{refetchQueries:[{query:m(),variables:y}]}),[C,{loading:k}]=(0,c.useMutation)(g,{onCompleted({reloadPublicIpAddresses:{task:e}}){const t=({id:s,status:n})=>{e?.id===s&&"done"===n&&(Z(),a.Observer.remove(t,"plesk:taskComplete"))};a.Observer.append(t,"plesk:taskComplete")}}),[T]=(0,c.useMutation)(j,{refetchQueries:[{query:m(),variables:y}],onCompleted(){(0,d.addToast)({intent:"success",message:b.lmsg("removeSuccess")})},onError({message:e}){(0,d.addToast)({intent:"danger",message:e}),Z()}}),[D]=(0,c.useMutation)(h,{refetchQueries:[{query:m(),variables:y}],onCompleted({repairIpAddress:{ipAddress:{ipAddress:e}={}}={}}){(0,d.addToast)({intent:"success",message:b.lmsg("repairSuccess",{address:e})})},onError({message:e}){(0,d.addToast)({intent:"danger",message:e})}}),{data:w,previousData:E,loading:L,refetch:F}=(0,p.useQuery)(m(),{variables:v,notifyOnNetworkStatusChange:!0,onCompleted(e){const t=Math.ceil(e.server.ipAddresses.total/u.itemsPerPage);u.page>t&&A((e=>({...e,page:t})))}}),{mode:{isDemo:O,isPowerUserPanel:R,canManageResellers:B}={},serverInfo:{isVirtuozzo:M}={},server:{firewall:H,ipAddresses:{list:$,total:N,canReloadPublic:U,hasPublicIp:q}={}}={}}=w||E,[Q,V]=(0,n.useState)([]),[W,z]=(0,n.useState)([]),[_,G]=(0,n.useState)(!1),X=!(O||M),K=!R&&B,Y=e.search||e.type,J="all"===u.itemsPerPage?1:Math.ceil(N/u.itemsPerPage),Z=async t=>{await F({...u,...e,...s,...t})},ee=(0,n.jsx)(i.Panel,{children:(0,n.jsxs)(i.ToolbarGroup,{title:"",className:"ip-address-page-filter",children:[(0,n.jsxs)("div",{children:[(0,n.jsx)(i.Hint,{children:(0,n.jsx)(f,{content:"address"})}),(0,n.jsx)(i.Input,{value:e.search,onChange:({target:e})=>t((t=>({...t,search:e.value})))})]}),(0,n.jsxs)("div",{children:[(0,n.jsx)(i.Hint,{children:(0,n.jsx)(f,{content:"type"})}),(0,n.jsxs)(i.Select,{size:"sm",value:e.type??"",onChange:e=>t((t=>({...t,type:e||void 0}))),children:[(0,n.jsx)("option",{value:"",children:b.lmsg("typeAny")}),(0,n.jsx)("option",{value:"SHARED",children:b.lmsg("typeShared")}),(0,n.jsx)("option",{value:"EXCLUSIVE",children:b.lmsg("typeExclusive")})]})]}),(0,n.jsx)(i.Button,{onClick:()=>{A((e=>({...e,page:1}))),Z({...e,page:1})},children:(0,n.jsx)(f,{content:"buttonSearch"})}),(0,n.jsx)(i.Button,{onClick:()=>{A((e=>({...e,page:1})));const e={search:null,type:null};t(e),Z({...e,page:1})},children:(0,n.jsx)(f,{content:"buttonResetSearch"})})]})}),te=X?(0,n.jsx)(i.Button,{component:r.default,to:"/cp/ip-address/add","data-type":"ip-add-address",icon:"plus",intent:"primary",tooltip:(0,n.jsx)(f,{content:"buttonAddNewIpAddressDescription"}),children:(0,n.jsx)(f,{content:"buttonAddNewIpAddress"})}):null,se=(0,n.jsxs)(n.Fragment,{children:[(0,n.jsxs)(i.Toolbar,{children:[(0,n.jsxs)(i.ToolbarGroup,{title:"",children:[te,(0,n.jsx)(i.Button,{"data-type":"ip-reread-configuration",icon:"refresh",onClick:I,state:P?"loading":void 0,tooltip:(0,n.jsx)(f,{content:"buttonRereadConfigurationDescription"}),children:(0,n.jsx)(f,{content:"buttonRereadConfiguration"})}),U?(0,n.jsx)(i.Button,{"data-type":"ip-button-reload-public",onClick:C,state:k?"loading":void 0,tooltip:(0,n.jsx)(f,{content:"buttonReloadPublicDescription"}),children:(0,n.jsx)(f,{content:"buttonReloadPublic"})}):null,H?.isEnabled?(0,n.jsx)(i.Button,{to:"/cp/firewall/",component:r.default,"data-type":"ip-button-firewall",tooltip:(0,n.jsx)(f,{content:"buttonFirewallDescription"}),children:(0,n.jsx)(f,{content:"buttonFirewall"})}):null]}),(0,n.jsx)(i.ToolbarGroup,{title:"",children:(0,n.jsx)(i.ListOperation,{critical:!0,confirmationText:()=>b.formatMessage("removeConfirmation",{name:(0,n.jsx)("b",{children:$.find((({id:e})=>Q[0]===e)).ipAddress}),count:Q.length}),actionButtonText:(0,n.jsx)(S,{content:"yesRemove"}),cancelButtonText:(0,n.jsx)(S,{content:"cancel"}),children:(0,n.jsx)(i.Button,{"data-type":"ip-remove",disabled:!Q.length,onClick:async()=>{z(Q),await T({variables:{ids:Q}}),z([])},icon:"recycle",children:(0,n.jsx)(f,{content:"buttonRemove"})})})}),(0,n.jsx)(i.ToolbarExpander,{}),(0,n.jsx)(i.ToolbarGroup,{title:"",groupable:!1,children:(0,n.jsx)(i.Button,{icon:"chevron-"+(_?"up":"down"),state:_?"active":void 0,onClick:()=>G((e=>!e))})})]}),_&&ee]}),ne=(0,n.useMemo)((()=>[{key:"IP_ADDRESS",title:(0,n.jsx)(f,{content:"address"}),type:"title",sortable:!0,render:({isMain:e,ipAddress:t,id:s,mask:a,isBroken:d,isBlacklisted:l,isMissing:o})=>(0,n.jsxs)(n.Fragment,{children:[(0,n.jsx)(i.Text,{bold:e,children:(0,n.jsx)(r.default,{"data-type":"ip-address-edit",to:`/cp/ip-address/${s}/edit`,children:t})}),(0,n.jsxs)(i.Hint,{children:[" ","/"," ",a]}),d?(0,n.jsx)("div",{style:{marginTop:"5px"},children:(0,n.jsxs)(i.Status,{intent:"warning",children:[(0,n.jsx)(f,{content:l?"ipAddressBlacklisted":"ipAddressBroken"})," ",o&&!l?(0,n.jsx)("a",{onClick:()=>D({variables:{id:s}}),children:(0,n.jsx)(f,{content:"repair"})}):null]})}):null]})},q?{key:"PUBLIC_IP_ADDRESS",title:(0,n.jsx)(f,{content:"publicAddress"}),sortable:!0,render:({isMain:e,publicIpAddress:t})=>(0,n.jsx)(i.Text,{bold:e,children:t})}:null,{width:"160px",key:"INTERFACE",title:(0,n.jsx)(f,{content:"interface"}),sortable:!0,render:({interface:e})=>e},{width:"150px",key:"TYPE",title:(0,n.jsx)(f,{content:"type"}),sortable:!0,render:({type:e})=>(0,n.jsx)(f,{content:"SHARED"===e?"typeSharedHint":"typeExclusiveHint"})},K?{width:"60px",key:"RESELLERS_COUNT",title:(0,n.jsx)(f,{content:"resellerCount"}),sortable:!0,render:({id:e,resellersCount:t})=>(0,n.jsx)("a",{href:`/plesk/server/ip-address@${(0,l.getId)(e)}/client@`,children:t})}:null,R?null:{width:"60px",key:"SUBSCRIPTIONS_COUNT",title:(0,n.jsx)(f,{content:"subscriptionCount"}),sortable:!0,render:({id:e,subscriptionsCount:t})=>(0,n.jsx)("a",{href:`/plesk/server/ip-address@${(0,l.getId)(e)}/domain@`,children:t})}].filter((e=>e))),[q,K,R,D]);return(0,n.jsxs)(n.Fragment,{children:[(0,n.jsx)(i.Paragraph,{children:(0,n.jsx)(f,{content:K?"hintWithResellers":"hint"})}),(0,n.jsx)(i.List,{loadingRows:W,"data-type":"ip-address-list",loading:L,rowKey:"id",sortColumn:s.sortColumn,sortDirection:s.sortDirection,onSortChange:e=>{o(e),Z(e)},columns:ne,onSelectionChange:e=>V(e),data:$,toolbar:se,totalRows:N,pagination:(0,n.jsx)(i.Pagination,{current:u.page,total:J,onSelect:e=>{A((t=>({...t,page:e}))),Z({page:e})},itemsPerPage:u.itemsPerPage,onItemsPerPageChange:e=>{const t={page:1,itemsPerPage:"all"===e?1e4:e};A(t),Z(t)},itemsPerPageOptions:[10,25,100,"all"]}),emptyView:(0,n.jsxs)(n.Fragment,{children:[Y&&se,(0,n.jsx)(i.ListEmptyView,{actions:!Y&&te})]})})]})}},1849:(e,t,s)=>{s.r(t),s.d(t,{default:()=>c});var n=s(240),i=s(694),r=s(286),a=s(90),d=s(689),l=s(1850),o=s(1852);const c=(0,i.withPageLayout)((()=>{const e=(0,d.useApolloClient)(),t=(0,n.useCallback)((({task:t})=>{const s=()=>e.refetchQueries({include:["IpAddressPage"]});if(t){const e=({id:n,status:i})=>{t?.id===n&&"done"===i&&(s(),a.Observer.remove(e,"plesk:taskComplete"))};a.Observer.append(e,"plesk:taskComplete")}else s()}),[e]);return(0,n.jsxs)(n.Fragment,{children:[(0,n.jsx)(l.default,{}),(0,n.jsx)(o.default,{onSuccess:t})]})}),(e=>{const{showFrames:t,pageHeader:s,pageSidebar:n}=(0,r.default)(),i=a.Locale.getSection("admin.controllers.ip-address.list").lmsg("title");return{...e,showFrames:t,pageHeader:{...s,helpMenu:{...s.helpMenu,helpContext:"ip-address.list"}},pageSidebar:n,pageContentHeader:{pageTitle:i,breadcrumbs:[n.isPowerUserPanel?null:{title:a.Locale.getSection("admin.controllers.home.admin").lmsg("title"),href:"/admin/home/"},{title:a.Locale.getSection("admin.controllers.server.tools").lmsg("title"),href:"/admin/server/tools/"},{title:i,href:"/cp/ip-address/"}].filter(Boolean)},pageTitle:i}}))},1848:(e,t,s)=>{s.r(t),s.d(t,{default:()=>n.default});var n=s(1849)},1716:(e,t,s)=>{s.r(t),s.d(t,{getId:()=>n});const n=e=>e?Number(atob(e).split(":")[1]):null},1851:(e,t,s)=>{s.r(t)}}]);
//# sourceMappingURL=list.js.map?22b3c15fd8d1a717cee2